slitaz-arm view rpi/tazbian @ rev 199

tazbian, piboot: misc fixes
author Pascal Bellard <pascal.bellard@slitaz.org>
date Tue Nov 18 10:50:30 2014 +0100 (2014-11-18)
parents c0c88b71a4b4
children f52ce3fe729d
line source
1 #!/bin/sh
2 #
3 # (C) 2014 SliTaz GNU/Linux - GPL2
4 #
5 # creates a debian package to install SliTaz on a RaspBian without
6 # repartitionning.
7 #
8 # AUTHORS: Pascal Bellard <pascal.bellard@slitaz.org>
9 #
11 [ $(id -u) -ne 0 ] && echo "Must be root. Abort." && exit 1
13 CURDIR=$PWD
14 TMPDIR=/tmp/rasp$$
15 mkdir -p $TMPDIR
16 cd $TMPDIR
17 DESTDIR=var/os/slitaz
18 URL=http://mirror.slitaz.org/arm/rpi/
19 wget -O - $URL | sed '/slitaz-rpi/!d;s/.*href=.\([a-zA-Z0-9._-]*\).*/\1/' | sort -r > index
20 VERSION="$(sed '/rpi-desktop/!d' index | sed 's/.*-desktop-\([0-9_-]*\).*/\1/;q')"
22 wget -O - $URL$(sed '/rpi-base/!d;q' index) | tar xjf -
23 wget -O - $URL$(sed '/rpi-desktop/!d;q' index) | tar xjf -
25 mkdir -p fs/$DESTDIR fs/boot/slitaz fs/boot/slitaz-base \
26 fs/boot/raspbian
28 # setup boot configuration
29 BASE=$(ls -d slitaz-rpi-base-*/boot)
30 [ ! -d "$BASE" ] && echo "Abort ($BASE) !" && exit 1
31 mv $BASE/kernel.img fs/boot/slitaz
32 cp $BASE/config.txt fs/boot/slitaz
33 cp $BASE/config.txt fs/boot/slitaz-base
34 echo "initramfs rootfs-base.gz" >> fs/boot/slitaz/config.txt
35 echo "entry=SliTaz $VERSION on SD-card" > fs/boot/slitaz/menu.txt
36 sed -i 's|kernel.img|../slitaz/&|' fs/boot/slitaz-base/config.txt
37 cp -a fs/boot/slitaz-base fs/boot/slitaz-live
38 echo "initramfs ../slitaz/rootfs-base.gz" >> fs/boot/slitaz-base/config.txt
39 echo "entry=SliTaz base $VERSION in RAM" > fs/boot/slitaz-base/menu.txt
40 echo "initramfs ../slitaz/rootfs-base.gz ../slitaz/rootfs-live.gz" >> fs/boot/slitaz-live/config.txt
41 echo "entry=SliTaz desktop $VERSION in RAM" > fs/boot/slitaz-live/menu.txt
43 # update base package
44 BASE=$(ls -d slitaz-rpi-base-*/rootfs)
45 [ ! -d "$BASE" ] && echo "Abort ($BASE) !" && exit 1
46 wget http://hg.slitaz.org/slitaz-arm/raw-file/tip/rpi/piboot
47 wget http://hg.slitaz.org/slitaz-boot-scripts/raw-file/tip/init
48 chmod +x piboot init
49 mv piboot $BASE/sbin
50 sed -i 's|mnt /mnt|mnt "/mnt -o noatime"|' init
51 mv init $BASE/sbin/pisubroot
52 wget http://cook.slitaz.org/cross/arm/packages/packages.list
53 while read file pkg extra ; do
54 [ -s boot$file ] && continue
55 [ -n "$extra" ] && continue
56 pkg=$(grep ^$pkg- packages.list | sort | sed q).tazpkg
57 wget http://cook.slitaz.org/cross/arm/packages/$pkg
58 tazpkg install $pkg --root=$BASE/
59 done <<EOT
60 /usr/lib/libz.so zlib
61 /usr/sbin/kexec kexec-tools
62 /usr/bin/tset ncursesw
63 /usr/bin/dialog dialog
64 /usr/lib/libxml2.so libxml2 aria2
65 /usr/bin/gpg-error libgpg-error aria2
66 /usr/lib/libgcrypt.so libgcrypt aria2
67 /usr/lib/libgmp.so gmp aria2
68 /usr/lib/libnettle.so nettle aria2
69 /usr/lib/libreadline.so readline aria2
70 /usr/bin/p11-kit p11-kit aria2
71 /usr/lib/libgnutls.so libgnutls aria2
72 /usr/lib/libtasn1.so libtasn1 aria2
73 /usr/bin/gnutls-cli gnutls aria2
74 /usr/bin/aria2c aria2 aria2
75 EOT
77 # deduplicate base & live
78 LIVE=$(ls -d slitaz-rpi-desktop-*/rootfs)
79 [ ! -d "$LIVE" ] && echo "Abort ($LIVE) !" && exit 1
80 LIVESZ=$(du -ks $LIVE | cut -f1)
81 ( cd $BASE/ ; find ! -type d ) | while read file; do
82 if [ -L $BASE/$file ]; then
83 [ -L $LIVE/$file ] &&
84 [ "$(readlink $BASE/$file)" == "$(readlink $LIVE/$file)" ] &&
85 rm -f $LIVE/$file
86 elif [ -f $BASE/$file ]; then
87 [ -f $LIVE/$file ] &&
88 cmp $BASE/$file $LIVE/$file > /dev/null 2>&1 &&
89 rm -f $LIVE/$file
90 elif [ -b $BASE/$file ]; then
91 [ -b $LIVE/$file ] &&
92 [ "$(stat -c '%a:%u:%g:%t:%T' $BASE/$file)" == \
93 "$(stat -c '%a:%u:%g:%t:%T' $LIVE/$file)" ] &&
94 rm -f $LIVE/$file
95 elif [ -c $BASE/$file ]; then
96 [ -c $LIVE/$file ] &&
97 [ "$(stat -c '%a:%u:%g:%t:%T' $BASE/$file)" == \
98 "$(stat -c '%a:%u:%g:%t:%T' $LIVE/$file)" ] &&
99 rm -f $LIVE/$file
100 fi
101 done
102 ( cd $BASE/ ; find -type d ) | while read dir; do
103 rmdir $LIVE/$dir 2> /dev/null
104 done
106 ( cd $BASE ; find * | cpio -o -H newc ) | \
107 gzip -9 > fs/boot/slitaz/rootfs-base.gz
108 ( cd $LIVE ; find * | cpio -o -H newc ) | \
109 gzip -9 > fs/boot/slitaz/rootfs-live.gz
110 if [ -x /usr/bin/advdef ]; then
111 advdef -z4 fs/boot/slitaz/rootfs-base.gz
112 advdef -z4 fs/boot/slitaz/rootfs-live.gz
113 fi
115 # Create raspbian package
116 echo "2.0" > debian-binary
117 cat > control <<EOT
118 Package: slitaz
119 Version: $VERSION-1
120 Architecture: armhf
121 Maintainer: Pascal Bellard <pascal.bellard@slitaz.org>
122 Installed-Size: $(($(du -ks fs | cut -f1) + $LIVESZ))
123 Section: miscellaneous
124 Priority: optional
125 Homepage: http://arm.slitaz.org/
126 Description: Tiny Linux distribution with multi boot feature
127 SliTaz can run fully in RAM or can be installed on the SD card in a
128 subdirectory of your Raspbian (example /$DESTDIR).
129 EOT
130 ( cd fs ; find * -type f -exec md5sum {} \; ) > md5sums
131 cat > postinst <<EOT
132 #!/bin/sh
134 set -e
136 RDEV=\$(sed 's/.*root=\([^ ]*\).*/\1/' /boot/cmdline.txt)
137 FSTYPE=\$(awk '/ \/ / { if (\$1 != "rootfs") print \$3 }' < /proc/mounts)
139 cd /$DESTDIR
140 zcat /boot/slitaz/rootfs-base.gz | cpio -idmu
141 zcat /boot/slitaz/rootfs-live.gz | cpio -idmu
142 [ -d mnt/raspbian ] || mkdir -p mnt/raspbian
143 if ! grep -qs raspbian etc/fstab ; then
144 sed -i 's/.*mmcblk0p[2-9].*/#&/' etc/fstab
145 cat >> etc/fstab <<EOM
146 \$RDEV /mnt/raspbian \$FSTYPE noatime 0 0
147 tmpfs /mnt/raspbian/$DESTDIR tmpfs size=0 0 0
148 EOM
149 fi
150 cd -
152 if [ ! -f /boot/menu.txt ]; then
154 for i in keyboard locale ; do
155 [ -s /etc/default/\$i ] && . /etc/default/\$i
156 done
157 KMAP=\$(find /$DESTDIR/usr/share/kbd/keymaps | grep /\$XKBLAYOUT[.-] | head -n1)
158 [ "\$KMAP" ] && KMAP="kmap=\$(basename \$KMAP .map.gz)"
159 cat > /boot/menu.txt <<EOM
160 title=Raspberry PI boot menu
161 subtitle=Select the OS with ARROW keys and hit RETURN
162 timeout=30
163 default=raspbian
164 \$KMAP
165 edittitle=Edit menu
166 readonly
167 #noedit
168 #nowebboot
169 #webpath=http://my.home.web.site/pxe/rpi/index.php http://or.this.one/rpi.txt
170 EOM
171 KERNEL=\$(sed '/^kernel/!d;s/.*=//' /boot/config.txt)
172 cp /boot/config.txt /boot/cmdline.txt /boot/raspbian/
173 mv /boot/\${KERNEL:-kernel.img} /boot/raspbian/
174 echo "entry=Raspbian \$(cat /etc/debian_version)" > /boot/raspbian/menu.txt
175 sed -i '/^kernel/d;/^initramfs/d' /boot/config.txt
176 echo "kernel=slitaz/kernel.img" >> /boot/config.txt
177 echo "initramfs slitaz/rootfs-base.gz" >> /boot/config.txt
178 echo "root=/dev/null rdinit=/sbin/piboot quiet" > /boot/cmdline.txt
179 L=
180 [ -s /$DESTDIR/usr/share/i18n/locales/\${LANG%.*} ] && L=lang=\${LANG%.*}
181 echo "root=/dev/null \$L \$KMAP rdinit=/sbin/pisubroot mount=\$RDEV subroot=$DESTDIR rootwait quiet" > /boot/slitaz/cmdline.txt
182 echo "root=/dev/null \$L \$KMAP quiet" > /boot/slitaz-base/cmdline.txt
183 cp /boot/slitaz-base/cmdline.txt /boot/slitaz-live/cmdline.txt
185 fi
187 echo "The SliTaz boot menu is available for next (re)boot."
189 exit 0
190 EOT
191 cat > postrm <<EOT
192 #!/bin/sh
194 purge()
195 {
196 rm -rf /$DESTDIR /boot/slitaz*
197 }
199 disable()
200 {
201 if [ -d /boot/rasbian ]; then
202 mv -f /boot/rasbian/* /boot
203 rm -rf /boot/rasbian
204 fi
205 rm -f /boot/menu.txt
206 }
208 case "\$1" in
209 purge)
210 disable
211 purge
212 ;;
213 remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
214 disable
215 ;;
216 *)
217 echo "postrm called with unknown argument \\\`\$1'" >&2
218 exit 0
219 esac
220 EOT
221 chmod +x postinst postrm
222 tar czf control.tar.gz md5sums control postinst postrm
223 rm -rf fs/$DESTDIR/*
224 cd fs ; tar czf ../data.tar.gz . ; cd ..
225 [ -x /usr/bin/ar ] || tazpkg get-install binutils
226 ar rcs slitaz-$VERSION-1_armhf.deb debian-binary control.tar.gz data.tar.gz
227 mv slitaz-$VERSION-1_armhf.deb $CURDIR
228 cd $CURDIR
229 rm -rf $TMPDIR
230 ls -l slitaz-$VERSION-1_armhf.deb